//+------------------------------------------------------------------+
//|                                                        RiEma.mq5 |
//|                                 Copyright 2016, Vasiliy Sokolov. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, Vasiliy Sokolov."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_plots   2
#property indicator_type1   DRAW_HISTOGRAM
#property indicator_color1  clrGray
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrRed
#include <RingBuffer\RiMACD.mqh>

input int FastPeriod = 9;
input int SlowPeriod = 26;
input int SignalPeriod = 12;
double buff[];
double signal[];
CRiMACD MACD;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0, buff, INDICATOR_DATA);
   SetIndexBuffer(1, signal, INDICATOR_DATA);
   MACD.SetFastPeriod(FastPeriod);
   MACD.SetSlowPeriod(SlowPeriod);
   MACD.SetSignalPeriod(SignalPeriod);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
{
//---
   bool calc = false;
   for(int i = prev_calculated; i < rates_total; i++)
   {
      MACD.AddValue(price[i]);
      buff[i] = MACD.Macd();
      signal[i] = MACD.Signal();
      calc = true;
   }
   if(!calc)
   {
      MACD.ChangeLast(price[rates_total-1]);
      buff[rates_total-1] = MACD.Macd();
      signal[rates_total-1] = MACD.Signal();
   }
   return(rates_total);
}
//+------------------------------------------------------------------+
